
#define LEFT_A  A0    //analog Left -->IR distance sensor in the left
#define RIGHT_A A3    //analog Right-->IR distance sensor inthe right
#define MIDDLE 10    //10cm switch sensor in the middle ---> less than 10cm return 0
#define LEFT_D  8    //Line Tracking Sensor in the left ----> find white return 1
#define RIGHT_D 9    //Line Tracking Sensor in the right----> find white return 1
#define E1 5         //Motor speed controll
#define E2 6         //Motor speed controll
#define M1 4         //Motor direction controll
#define M2 7         //Motot direction controll
int Distance_L=0,Distance_R=0;
int Switch_L,Switch_M,Switch_R;
//函数功能：定义每个引脚为输入或输出型，只运行一遍
void setup()
{
pinMode(LEFT_A,INPUT);   //引脚LEFT为接守型的引脚
pinMode(RIGHT_A,INPUT);
pinMode(MIDDLE,INPUT);
pinMode(LEFT_D,INPUT);
pinMode(RIGHT_D,INPUT);
for (int i=4;i<8;i++)
pinMode(i,OUTPUT);       //引脚4,5,6,7,为输出型的引脚
//Serial.begin(9600); 
delay(2000);
}
//函数功能：程序运行时loop（）会一直循环运行，从而不断获得传感器的值和做出相应的动作。
void loop()
{
switch (Get_state())
{
case 0: {Turn_Left(125,125);Serial.println("L");}        break;//收到0，执行左转程序
case 1: {Turn_Right(125,125);Serial.println("R");}       break;//收到1，执行右转程序
case 2: {Turn_Forward(255,255);Serial.println("F");delay(25);}     break;
case 3: {Turn_Forward(175,175);Serial.println("F");}     break;
case 4: {Turn_Back(250,250);Serial.println("B");delay(20);}        break;
default :break;
}
//delay(200);
}
//函数功能：获得各个传感器的的值并通过传感器的值判断小车处在的状态
int Get_state()
{
int St=0;                     //状态值，开始时为0
Distance_L=analogRead(LEFT_A);//读取左前方距离传感器的值
Distance_R=analogRead(RIGHT_A);//读取右前方距离传感器的值
Switch_L  =digitalRead(LEFT_D);//读取左前方巡线传感器的值-->对地面的传感器
Switch_R  =digitalRead(RIGHT_D);//读取右前方巡线传感器的值
Switch_M  =digitalRead(MIDDLE);// 读取中间10cm开关传感器的值
if (Distance_L>150)  St=St+1;  // 如果左前方距离值大于300，状态值加1
if (Distance_R>150)  St=St+2;  // 如果右前方距离值大于300，状态值加2
if (Switch_L==1)  St=St+4;     // 如果左前方巡线传感器测到白线，状态值+4
if (Switch_R==1)  St=St+8;//如果右前方巡线传感器测到白线，状态值加8
if (Switch_M==0)  St=St+16;//如果中间测到物体，状态值加16  
//  Serial.println(St);
//  Serial.print( Distance_L);Serial.print("  ");
//  Serial.print( Distance_R);Serial.print("  ");
//  Serial.print(  Switch_L);Serial.print("  ");
//  Serial.print( Switch_R);Serial.print("  ");
//  Serial.println(  Switch_M); 
//  delay(1000);
 //--->测试时输出数据供调试用的，作用为输出各个测得的值以下为状态分类
if (St==0 || St==1 || St==8 || St==9 || St==10 || St==11)
return 0;
else if ( St==2 || St==5 || St==6 || St==7 || St==20 || St==21|| St==22 || St==23)
return 1;
else if ( St==16 || St==17 || St==18 || St==19 || St==3 )
return 2;
//else if(St==0)
//return 3;
else return 4;
//以return 0 为例，如果小车在：
//情况1:左边测到有物体--->St=1
//情况2：右边巡线传感器测到白线，表示右前方已经在边界上-->St=8
//情况3：情况1和情况2同时发生-->St=1+8=9
//情况4：右边测到边界但右边也发现物体，-->St=8+2
//情况5：右边测到边界且左右都测到物体，-->St=8+2+1=11
//这几种情况都表示小车需要左转。就返回0给主函数，主函数收到0就会执行左转程序
}

//功能：左转，左右电机速度为x，y
void Turn_Left(int x,int y)
{
analogWrite (E1,x);      //PWM Speed Control
digitalWrite(M1,HIGH);    
analogWrite (E2,y);    
digitalWrite(M2,LOW);
}
void Turn_Right(int x,int y)
{
analogWrite (E1,x);      //PWM Speed Control
digitalWrite(M1,LOW); 
analogWrite (E2,y);    
digitalWrite(M2,HIGH);
}
void Turn_Forward(int x,int y)
{
analogWrite (E1,x);      //PWM Speed Control
digitalWrite(M1,HIGH);    
analogWrite (E2,y);    
digitalWrite(M2,HIGH);
}
void Turn_Back(int x,int y)
{
analogWrite(E1,x);analogWrite(E2,y);
digitalWrite(M1,LOW);digitalWrite(M2,LOW);
}

